unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, RXShell, Placemnt, Registry, AppEvent;

type
  TForm1 = class(TForm)
    RxTrayIcon1: TRxTrayIcon;
    PopupMenu1: TPopupMenu;
    M1: TMenuItem;
    M2: TMenuItem;
    M3: TMenuItem;
    AppEvents1: TAppEvents;
    RxTrayIcon2: TRxTrayIcon;
    M4: TMenuItem;
    procedure M2Click(Sender: TObject);
    procedure M1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RxTrayIcon1Click(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure M3Click(Sender: TObject);
    procedure AppEvents1Restore(Sender: TObject);
    procedure M4Click(Sender: TObject);
    procedure RxTrayIcon2Click(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure OnM1Change;
    procedure OnM4Change;
  end;

const ProxyKey='\Software\Microsoft\Windows\CurrentVersion\Internet Settings';
      IEKey='\Software\Microsoft\Internet Explorer\Main';
var
  Form1: TForm1;
  ProxyEnabled: Integer=0;
  PictsEnabled: Integer=0;

implementation

{$R *.DFM}

//    
function iif(Flag: Boolean; Expr1,Expr2: Variant): Variant;
begin
  if Flag then Result:=Expr1 else Result:=Expr2;
end;

procedure TForm1.M2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.OnM1Change;
begin
  ProxyEnabled:=Integer(M1.Checked);
  RxTrayIcon1.Icon:=RxTrayIcon1.Icons[ProxyEnabled];
  with TRegistry.Create do begin
    RootKey:=HKEY_CURRENT_USER;
    LazyWrite:=False;
    OpenKey(ProxyKey,True);
    WriteInteger('ProxyEnable',ProxyEnabled);
    Free;
  end;
end;

procedure TForm1.OnM4Change;
var SValue: String;
begin
  PictsEnabled:=Integer(M4.Checked);
  RxTrayIcon2.Icon:=RxTrayIcon2.Icons[PictsEnabled];
  with TRegistry.Create do begin
    RootKey:=HKEY_CURRENT_USER;
    LazyWrite:=False;
    OpenKey(IEKey,True);
    SValue:=iif(PictsEnabled=1,'yes','no');
    WriteString('Display Inline Images',SValue);
    WriteString('Display Inline Videos',SValue);
    WriteString('Play_Animations',SValue);
    WriteString('Play_Background_Sounds',SValue);
    Free;
  end;
end;

procedure TForm1.M1Click(Sender: TObject);
begin
  M1.Checked:=not M1.Checked;
  OnM1Change;
end;

procedure TForm1.FormCreate(Sender: TObject);
var Buff: array[1..4] of byte;
begin
  with TRegistry.Create do begin
    RootKey:=HKEY_CURRENT_USER;
    if OpenKey(ProxyKey,True) then begin
      if GetDataType('ProxyEnable')=rdInteger then ProxyEnabled:=ReadInteger('ProxyEnable')
      else if GetDataType('ProxyEnable')=rdBinary then begin
        ReadBinaryData('ProxyEnable',Buff,4);
        ProxyEnabled:=Buff[1];
      end;
    end;
    if OpenKey(IEKey,True) then
      PictsEnabled:=iif(LowerCase(ReadString('Display Inline Images'))='yes',1,0);
    Free;
  end;
  if ProxyEnabled=1 then M1.Checked:=True;
  if PictsEnabled=1 then M4.Checked:=True;
  RxTrayIcon1.Icon:=RxTrayIcon1.Icons[ProxyEnabled];
  RxTrayIcon2.Icon:=RxTrayIcon2.Icons[PictsEnabled];
  Application.Minimize;
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TForm1.M3Click(Sender: TObject);
begin
  ShowMessage('Proxy Switcher v.1.02 by Eugene A. Kalinin.'#13#10#13#10+
              'For activate switch you need to restart Internet Explorer (sorry) !');
end;

procedure TForm1.AppEvents1Restore(Sender: TObject);
begin
  Application.Minimize;
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TForm1.M4Click(Sender: TObject);
begin
  M4.Checked:=not M4.Checked;
  OnM4Change;
end;

procedure TForm1.RxTrayIcon1Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  M1.Click;
end;

procedure TForm1.RxTrayIcon2Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  M4.Click;
end;

end.
